﻿Imports System.ComponentModel
Imports System.Reflection

'Beachte: Dieser ColorSelector feuert idiotischerweise 2 verschiedene Events, wenn eine Farbe gewählt wird - dieses nur zu Demonstrationszwecken
<DefaultEvent("SelectedColorChanged")> _
Public Class uclColorSelector

   Public Class ColorChangedEventArgs : Inherits EventArgs
      Public ReadOnly Color As Color
      Public Sub New(ByVal color As Color)
         Me.Color = color
      End Sub
   End Class

   Public Event ColorChanged As EventHandler(Of ColorChangedEventArgs)

   Protected Sub OnColorChanged(ByVal e As ColorChangedEventArgs)
      RaiseEvent ColorChanged(Me, e)
   End Sub

   Private _Brushes As New List(Of SolidBrush)

   Private Sub ListBox_SelectedIndexChanged( _
         ByVal sender As Object, ByVal e As EventArgs) Handles ListBox1.SelectedIndexChanged
      OnColorChanged(New ColorChangedEventArgs(_Brushes(ListBox1.SelectedIndex).Color))
   End Sub

   Public Event SelectedColorChanged As EventHandler

   Private Sub ListBox1_SelectedIndexChanged( _
         ByVal sender As Object, ByVal e As EventArgs) Handles ListBox1.SelectedIndexChanged
      RaiseEvent SelectedColorChanged(Me, EventArgs.Empty)
   End Sub

   Public ReadOnly Property SelectedColor As Color
      Get
         Return _Brushes(ListBox1.SelectedIndex).Color
      End Get
   End Property

   Private Sub ListBox1_DrawItem(ByVal sender As Object, ByVal e As DrawItemEventArgs) _
         Handles ListBox1.DrawItem
      e.DrawBackground()
      Dim brsh = _Brushes(e.Index)
      With e.Bounds
         e.Graphics.FillRectangle(brsh, .X + 2, .Y + 3, .Width - 5, .Height - 6)
      End With
      With brsh.Color
         Dim col = If(CInt(.R) + .B + .G > 400, Color.Black, Color.White)
         TextRenderer.DrawText(e.Graphics, .Name, Font, e.Bounds, col)
      End With
   End Sub

   Private Sub uclColorSelector_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
      For Each pinf As PropertyInfo In GetType(Brushes).GetProperties().Skip(1)
         _Brushes.Add(DirectCast(pinf.GetValue(Nothing, Nothing), SolidBrush))
      Next
      ListBox1.DataSource = _Brushes
   End Sub

   ''Quick&Dirty - Frickel-Lösung:
   'Private Sub ListBox1_SelectedIndexChanged( _
   '      ByVal sender As Object, ByVal e As EventArgs) Handles ListBox1.SelectedIndexChanged
   '   Form1.Button1.BackColor = _Brushes(ListBox1.SelectedIndex).Color
   'End Sub

End Class
