Public Class Form1

   Private _SelStore As New SelStore

   Private Sub frmEventDemo_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
      'per databinding auf SelectedColor "horchen"
      Me.Button3.DataBindings.Add("BackColor", UclColorSelector1, "SelectedColor")
      RichTextBox1.Text = "012345"
      RichTextBox1.SelectionStart = 3
      _SelStore.Store(RichTextBox1)
      AddHandler RichTextBox1.SelectionChanged, AddressOf RichTextBox1_SelectionChanged
   End Sub

   Private Sub RichTextBox1_SelectionChanged(ByVal sender As Object, ByVal e As EventArgs)
      Dim allowed = "0123456789"
      With RichTextBox1
         If .Text.All(Function(c) allowed.Contains(c)) Then
            _SelStore.Store(RichTextBox1)
         Else
            RemoveHandler .SelectionChanged, AddressOf RichTextBox1_SelectionChanged
            _SelStore.Restore(RichTextBox1)
            AddHandler .SelectionChanged, AddressOf RichTextBox1_SelectionChanged
         End If
      End With
   End Sub

   Private Sub UclColorSelector1_SelectedColorChanged( _
         ByVal sender As Object, ByVal e As EventArgs) Handles UclColorSelector1.SelectedColorChanged
      Me.Button1.BackColor = UclColorSelector1.SelectedColor
   End Sub

   Private Sub UclColorSelector1_ColorChanged( _
         ByVal sender As Object, ByVal e As uclColorSelector.ColorChangedEventArgs) Handles UclColorSelector1.ColorChanged
      'zur Benutzung isses etwas bequemer, dass e die Color gleich mitliefert - aber der Mehr-Aufwand auf Sender-Seite wrde sich hchstens lohnen, wenn dafr die uclColorSelector.SelectedColor - Property eingespart wrde.
      Me.Button2.BackColor = e.Color
   End Sub

End Class

Public Class SelStore
   Private Text As String
   Private Start, Length As Integer
   Public Sub Store(ByVal tb As RichTextBox)
      Text = tb.Text
      Start = tb.SelectionStart
      Length = tb.SelectionLength
   End Sub
   Public Sub Restore(ByVal tb As RichTextBox)
      tb.Text = Text
      tb.Select(Start, Length)
   End Sub
End Class